<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers;

use JsonSerializable;
use InvalidArgumentException;
use Illuminate\Contracts\Support\Jsonable;
use Illuminate\Contracts\Support\Arrayable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia;

/**
 * Class PocetKontrolPodlaDruhuAHodnoteniaDataTableRow
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers
 */
final class PocetKontrolPodlaDruhuAHodnoteniaDataTableRow implements Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var array
     */
    private array $hodnoteniePocet = [];

    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    private DruhEmisnejKontrolyEnum $druhEmisnejKontrolyEnum;

    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * PocetKontrolPodlaDruhuAHodnoteniaDataTableRow constructor.
     *
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia
     */
    public function __construct(PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia)
    {
        $this->druhEmisnejKontrolyEnum = $pocetKontrolPodlaDruhuAHodnotenia->druh();

        foreach (HodnotenieEmisnejKontrolyEnum::toArray() as $k => $v) {
            $this->hodnoteniePocet[$k] = 0;
        }

        $this->add($pocetKontrolPodlaDruhuAHodnotenia);
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaDruhuAHodnotenia $pocetKontrolPodlaDruhuAHodnotenia): self
    {
        if (false === $this->druhEmisnejKontrolyEnum->equals($pocetKontrolPodlaDruhuAHodnotenia->druh())) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa druh emisnej kontroly %s, vtupny atribut obsahuje druh emisnej kontroly %s',
                $this->druhEmisnejKontrolyEnum->value,
                $pocetKontrolPodlaDruhuAHodnotenia->druh()->value
            ));
        }

        $this->hodnoteniePocet[$pocetKontrolPodlaDruhuAHodnotenia->hodnotenie()->value] += $pocetKontrolPodlaDruhuAHodnotenia->pocet();

        $this->spolu += $pocetKontrolPodlaDruhuAHodnotenia->pocet();

        return $this;
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'hodnotenia' => $this->hodnoteniePocet,
            'druh' => $this->druhEmisnejKontrolyEnum->value,
            'spolu' => $this->spolu,
        ];
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function jsonSerialize()
    {
        return $this->toArray();
    }
}
